Missing / Null Values in React

Using ApexCharts with React

This Missing / Null Values example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Gateway 1',
        data: [
          {
            x: 'Dec 23 2024',
            y: null,
          },
          {
            x: 'Dec 24 2024',
            y: 44,
          },
          {
            x: 'Dec 25 2024',
            y: 31,
          },
          {
            x: 'Dec 26 2024',
            y: 38,
          },
          {
            x: 'Dec 27 2024',
            y: null,
          },
          {
            x: 'Dec 28 2024',
            y: 32,
          },
          {
            x: 'Dec 29 2024',
            y: 55,
          },
          {
            x: 'Dec 30 2024',
            y: 51,
          },
          {
            x: 'Dec 31 2024',
            y: 67,
          },
          {
            x: 'Jan 01 2025',
            y: 22,
          },
          {
            x: 'Jan 02 2025',
            y: 34,
          },
          {
            x: 'Jan 03 2025',
            y: null,
          },
          {
            x: 'Jan 04 2025',
            y: null,
          },
          {
            x: 'Jan 05 2025',
            y: 11,
          },
          {
            x: 'Jan 06 2025',
            y: 4,
          },
          {
            x: 'Jan 07 2025',
            y: 15,
          },
          {
            x: 'Jan 08 2025',
            y: null,
          },
          {
            x: 'Jan 09 2025',
            y: 9,
          },
          {
            x: 'Jan 10 2025',
            y: 34,
          },
          {
            x: 'Jan 11 2025',
            y: null,
          },
          {
            x: 'Jan 12 2025',
            y: null,
          },
          {
            x: 'Jan 13 2025',
            y: 13,
          },
          {
            x: 'Jan 14 2025',
            y: null,
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'area',
        height: 350,
        animations: {
          enabled: false,
        },
        zoom: {
          enabled: false,
        },
      },
      dataLabels: {
        enabled: false,
      },
      stroke: {
        curve: 'straight',
      },
      fill: {
        type: 'gradient',
        gradient: {
          opacityFrom: 0.5,
          opacityTo: 0.1,
        },
      },
      markers: {
        size: 5,
        hover: {
          size: 9,
        },
      },
      title: {
        text: 'Sensor Uptime',
      },
      subtitle: {
        text: 'Dropped readings (null values) leave gaps in the area',
      },
      tooltip: {
        intersect: true,
        shared: false,
      },
      xaxis: {
        type: 'datetime',
      },
      yaxis: {
        title: {
          text: 'Throughput (Mbps)',
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="area"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

<template>
  <div>
    <div id="chart">
      <apexchart
        type="area"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Gateway 1',
          data: [
            {
              x: 'Dec 23 2024',
              y: null,
            },
            {
              x: 'Dec 24 2024',
              y: 44,
            },
            {
              x: 'Dec 25 2024',
              y: 31,
            },
            {
              x: 'Dec 26 2024',
              y: 38,
            },
            {
              x: 'Dec 27 2024',
              y: null,
            },
            {
              x: 'Dec 28 2024',
              y: 32,
            },
            {
              x: 'Dec 29 2024',
              y: 55,
            },
            {
              x: 'Dec 30 2024',
              y: 51,
            },
            {
              x: 'Dec 31 2024',
              y: 67,
            },
            {
              x: 'Jan 01 2025',
              y: 22,
            },
            {
              x: 'Jan 02 2025',
              y: 34,
            },
            {
              x: 'Jan 03 2025',
              y: null,
            },
            {
              x: 'Jan 04 2025',
              y: null,
            },
            {
              x: 'Jan 05 2025',
              y: 11,
            },
            {
              x: 'Jan 06 2025',
              y: 4,
            },
            {
              x: 'Jan 07 2025',
              y: 15,
            },
            {
              x: 'Jan 08 2025',
              y: null,
            },
            {
              x: 'Jan 09 2025',
              y: 9,
            },
            {
              x: 'Jan 10 2025',
              y: 34,
            },
            {
              x: 'Jan 11 2025',
              y: null,
            },
            {
              x: 'Jan 12 2025',
              y: null,
            },
            {
              x: 'Jan 13 2025',
              y: 13,
            },
            {
              x: 'Jan 14 2025',
              y: null,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'area',
          height: 350,
          animations: {
            enabled: false,
          },
          zoom: {
            enabled: false,
          },
        },
        dataLabels: {
          enabled: false,
        },
        stroke: {
          curve: 'straight',
        },
        fill: {
          type: 'gradient',
          gradient: {
            opacityFrom: 0.5,
            opacityTo: 0.1,
          },
        },
        markers: {
          size: 5,
          hover: {
            size: 9,
          },
        },
        title: {
          text: 'Sensor Uptime',
        },
        subtitle: {
          text: 'Dropped readings (null values) leave gaps in the area',
        },
        tooltip: {
          intersect: true,
          shared: false,
        },
        xaxis: {
          type: 'datetime',
        },
        yaxis: {
          title: {
            text: 'Throughput (Mbps)',
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Missing / Null Values in Angular

Using ApexCharts with Angular

This Missing / Null Values example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Gateway 1',
              data: [
                {
                  x: 'Dec 23 2024',
                  y: null,
                },
                {
                  x: 'Dec 24 2024',
                  y: 44,
                },
                {
                  x: 'Dec 25 2024',
                  y: 31,
                },
                {
                  x: 'Dec 26 2024',
                  y: 38,
                },
                {
                  x: 'Dec 27 2024',
                  y: null,
                },
                {
                  x: 'Dec 28 2024',
                  y: 32,
                },
                {
                  x: 'Dec 29 2024',
                  y: 55,
                },
                {
                  x: 'Dec 30 2024',
                  y: 51,
                },
                {
                  x: 'Dec 31 2024',
                  y: 67,
                },
                {
                  x: 'Jan 01 2025',
                  y: 22,
                },
                {
                  x: 'Jan 02 2025',
                  y: 34,
                },
                {
                  x: 'Jan 03 2025',
                  y: null,
                },
                {
                  x: 'Jan 04 2025',
                  y: null,
                },
                {
                  x: 'Jan 05 2025',
                  y: 11,
                },
                {
                  x: 'Jan 06 2025',
                  y: 4,
                },
                {
                  x: 'Jan 07 2025',
                  y: 15,
                },
                {
                  x: 'Jan 08 2025',
                  y: null,
                },
                {
                  x: 'Jan 09 2025',
                  y: 9,
                },
                {
                  x: 'Jan 10 2025',
                  y: 34,
                },
                {
                  x: 'Jan 11 2025',
                  y: null,
                },
                {
                  x: 'Jan 12 2025',
                  y: null,
                },
                {
                  x: 'Jan 13 2025',
                  y: 13,
                },
                {
                  x: 'Jan 14 2025',
                  y: null,
                },
              ],
            },
          ],
          chart: {
            type: 'area',
            height: 350,
            animations: {
              enabled: false,
            },
            zoom: {
              enabled: false,
            },
          },
          dataLabels: {
            enabled: false,
          },
          stroke: {
            curve: 'straight',
          },
          fill: {
            type: 'gradient',
            gradient: {
              opacityFrom: 0.5,
              opacityTo: 0.1,
            },
          },
          markers: {
            size: 5,
            hover: {
              size: 9,
            },
          },
          title: {
            text: 'Sensor Uptime',
          },
          subtitle: {
            text: 'Dropped readings (null values) leave gaps in the area',
          },
          tooltip: {
            intersect: true,
            shared: false,
          },
          xaxis: {
            type: 'datetime',
          },
          yaxis: {
            title: {
              text: 'Throughput (Mbps)',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}